# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Net-FTPSSL
Version:	0.23
Release:	1.%{__distinit}%{__distvers}
Summary:	Perl module for FTP over SSL/TLS
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Net-FTPSSL/
Source0:	http://search.cpan.org/CPAN/authors/id/C/CL/CLEACH/Net-FTPSSL-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(IO::Socket::INET)
BuildRequires:	perl(IO::Socket::SSL) >= 1.86
BuildRequires:	perl(Net::HTTPTunnel)
BuildRequires:	perl(Net::SSLeay::Handle)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Time::Local)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Net::HTTPTunnel)

%description
Net::FTPSSL is a class implementing a simple FTP client over a Secure
Sockets Layer (SSL) or Transport Layer Security (TLS) connection written in
Perl as described in RFC959 and RFC2228. It will use TLS by default.

%prep
%setup -q -n Net-FTPSSL-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}

%check
PERL_MM_USE_DEFAULT=1 make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%{perl_vendorlib}/Net/
%{_mandir}/man3/Net::FTPSSL.3pm*

%changelog
* Tue Aug  6 2013 Paul Howarth <paul@city-fan.org> - 0.23-1
- Update to 0.23
  - Added clarification to use of SSL_Client_Certificate option in pod text
  - Added support for tunneling through a proxy server via the ProxyArgs option
    (CPAN RT#82094)
  - Added optional proxy server questions if Net::HTTPTunnel is installed for
    the test scripts (t/*.t)
  - Fixed bug in login() so the call to help() only happens if the login is
    successful
  - Avoid IO-Socket-SSL versions 1.79 to 1.85 due to bug when using
    certificates for the Data Channel and getting a bogus Man-In-The-Middle
    (MITM) warning (CPAN RT#84376)
  - Avoid MITM warning when not using certificates (CPAN RT#85420)
  - Fixed masking issue when writing to the log file when the value that needed
    to be masked contained regex special chars
  - Added clarification that any warnings printed below the 10-complex.t tests
    are just that: warnings, not errors preventing things from working; they
    are collected so the developer can be notified about them for fixing in
    future releases
- BR:/R: perl(Net::HTTPTunnel)
- Bump perl(IO::Socket::SSL) version requirement to 1.86

* Tue Jul 10 2012 Paul Howarth <paul@city-fan.org> - 0.22-2
- Perl 5.16 rebuild

* Sat May 26 2012 Paul Howarth <paul@city-fan.org> - 0.22-1
- Update to 0.22
  - CPAN RT#77072 requested to autodetect the need for using the PRET command;
    the docs in the POD now mark the Pret option as optional for cases where
    auto-detect doesn't work
  - Fixed issue with ccc that the server sometimes responds to a successful NOOP
    twice, resulting in command/resonses getting out of sync
  - Fixed quot() bug introduced with uc() fix for CPAN RT#74025 in 0.21
  - Fixed the return code in restart() to always be 1 instead of undef, since
    it never fails
- Don't need to remove empty directories from buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Tue Feb 21 2012 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Fixed bad call to _croak_or_return () in _get_data_channel() when dealing
    with failed certificates for data connections
  - New option to execute PRET (for distributed FTP data channel transfers)
    before all PASV calls (CPAN RT#74547)
  - Updated t/10-complex.t to dynamically check if PRET is needed
  - Added checks to avoid warnings with uc(undef) (CPAN RT#74035)
  - Fixed both test cases to no longer send Port as undefined to get rid of
    warnings in log file (passing undef wasn't realistic, was just convenient)
  - t/10-complex.t now explicitly checks if any warnings are generated and does
    a request for feadback instead of as an error if any are found, which
    should help considerably with debugging any code changes in the future
  - Added new internal method _feat() to get additional commands to be
    recognized by supported()
  - Enhanced _help() in parsing its response from the server and other
    significant enhancements (major rewrite of this one method)
  - Above rewrite uncovered bug in t/10-complex.t to fix in a supported() test
  - Did some tweaking to the workings of the OverrideHELP option due to changes
    in _help() and supported()
  - Updated POD for supported() to describe changes to functionality
- Add buildreqs for Perl core modules that might be dual-lived

* Mon Jan  2 2012 Paul Howarth <paul@city-fan.org> - 0.20-1
- Update to 0.20
  - Fixed CPAN RT#73115 where it looks like the response() had unexpected
    breaks in it. Instead of returning "xyz message", the FTPS server was
    returning "x" on one line and "yz message" on another line, and the code
    was treating "x" as the entire response (since there was no "-" after it).
    Fixed so that if a response starts with a number that's less than 3 digits
    with nothing else following it, to assume we hit this bug. The risk to
    this fix is that we might try to read past the response on some other
    server and cause things to hang. So that's an issue to keep an eye out on
    after this release.
  - Fixed minor issue with "HELP" not supported on some boxes. If this happens,
    supported() will now always return false unless you use OverrideHELP.
  - Now prints the hash values chosen for new() to the logs.
  - Fixed so scrubbing out sensitive info from the logs is only done when debug
    is turned on instead of doing it all the time.
  - Reorganized the options to new() in the POD to put the less useful and
    special case options to new() last.
  - Other minor POD corrections and additions.

* Thu Oct 20 2011 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19
  - If you use SSL_Advanced, it now writes to STDERR that you are using a
    deprecated feature
  - Modified 10-complex.t and 20-certificate.t to honor the PERL_MM_USE_DEFAULT
    environment variable for the smoke testers to always use defaults, which
    skips executing these 2 scripts (CPAN RT#69982)
  - Fixed typos in POD text and some misleading comments (CPAN RT#70438)
  - Updated the README file to include comments on t/20-certificate.t and what
    changes are required before you can use it
  - Updated t/20-certificate.t to highlight the section of code that the README
    file is talking about and the initial prompt to remind the user to see the
    the README file for the needed modifications before running the test!
- BR: perl(Carp)

* Wed Aug  3 2011 Paul Howarth <paul@city-fan.org> - 0.18-1
- Update to 0.18
  - More fixes/clarifications to the POD text
  - Fixed minor wild card issue with LIST & NLST if "+" was in the file name
  - Added LocalAddr option to new(); works against both the command channel
    and the data channel
  - Added restart() function to be compatible with Net::FTP for restarts
  - Added ability to restart downloads/get() where previous attempt left off
  - Added ability to restart uploads/put() where previous attempt left off
  - Added append() command [APPE]; it also uses OFFSET, but doesn't send the
    REST command to the server
  - Masks out the user name used when generating a log file, similar to how
    this is already done for the password except that it must also hide it in
    the response to USER & PASS; it's only masked when written to the log -
    message() and last_message() still return the user name unmasked in any
    response string!
  - Fixed a bug in t/10-complex.t and added optional environment variables
    for some of the connection values to make it easier for to quickly re-run
    tests during development without having to key in answers to questions
    with no good default values over and over again
  - Added SSL_Client_Certificate to support client certificates on the data
    channel as well as the command channel (CPAN RT#69327)
  - Deprecated SSL_Advanced in favor of SSL_Client_Certificate; SSL_Advanced is
    now just an alias for SSL_Client_Certificate for backwards compatibility;
    the new name better describes what we are trying to do with it now that
    this feature is supported
  - Wrote t/20-certificate.t to test this out, though this and t/10-complex.t
    are probably incompatible in most settings - anyone else trying to use this
    test case will have to modify the code to point to their certificate and
    provide its password, since the upstream test client certificate isn't
    going to be published
  - Calls to command() now return a reference to this class so that you can
    code something like: "if ($ftps->command("NOOP")->response() == CMD_OK)"
  - Modifed Net::FTPSSL to use the new command()->response() format internally

* Tue Jul  5 2011 Paul Howarth <paul@city-fan.org> - 0.17-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Tue Jan  4 2011 Paul Howarth <paul@city-fan.org> - 0.17-1
- Update to 0.17
  - Fixed a subtle bug in response(), which now tests if parse succeeded
    instead of assuming it
  - Reordered the methods in the POD
  - Reworked t/10-complex.t quite a bit
  - Fixed the smoke tester failures (CPAN RT#64109)
  - t/10-complex.t now checks if OverridePASV or OverrideHELP are needed against
    the test server and dynamically adds it for the test cases if needed
  - Added PASV/EPSV prompt to t/10-complex.t script instead of assuming PASV
- Drop patch for CPAN RT#64109, now fixed upstream

* Wed Dec 22 2010 Paul Howarth <paul@city-fan.org> - 0.16-1
- Update to 0.16 (see Changes for details)
- Fix incorrect skip count in t/10-complex.t (CPAN RT#64109)

* Wed Dec 22 2010 Paul Howarth <paul@city-fan.org> - 0.15-3
- Import from Fedora

* Tue Dec 21 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.15-2
- Rebuild to fix problems with vendorarch/lib (#661697)

* Fri Jul 02 2010 Lubomir Rintel (Good Data) <lubo.rintel@gooddata.com> 0.15-1
- Specfile autogenerated by cpanspec 1.78
- Add missing BR, fix up some strings
